//NAME:Caleb Bird
//ID: 1289680
//??References??

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.*;

public class TabRndListGen {
    public static void main(String[] args) {
	try{
	    if (args.length != 3){
		System.out.println("Usage: TabRndListGen <inputFilename> <outputCount> <outputFilename>");
	    }
	    else{
		String inputFilename = args[0];
		int outputCount  = Integer.parseInt(args[1]);
		String outputFilename = args[2];
		
		BufferedReader buf = new BufferedReader(new FileReader(inputFilename));
		FileWriter fw = new FileWriter(outputFilename);
		//FileWriter fw = new FileWriter("hathiRndIDList.txt");
		//BufferedReader buf = new BufferedReader(new FileReader("hathiDocIDList.txt"));

		ArrayList<String> list = new ArrayList<String>();
		ArrayList<String> subList;
		String line = null;
		String[] item;

		//Add items to Array
		while ((line = buf.readLine()) != null) {
			//Split line by tab
			item = line.split("\t", -1);
			//Add first element (ID)
		    list.add(item[0]);	    
		}
		//randomize list
		Collections.shuffle(list);

		//Take <outputCount>
		subList = new ArrayList<String>(list.subList(0,outputCount));

		//Write these to new file
		for(int i =0; i < subList.size(); i++){
		    fw.write(subList.get(i) + '\n');
		}
			
		buf.close();
		fw.close();
	    }
	}catch(Exception e){
	    e.printStackTrace();
	}
    }
}
// Returns 42474

//REFERNECES
//https://www.javatpoint.com/java-filewriter-class
//https://docs.oracle.com/javase/8/docs/api/index.html?java/io/FileWriter.html
//https://www.geeksforgeeks.org/randomly-select-items-from-a-list-in-java/
//https://codereview.stackexchange.com/questions/146551/picking-10-distinct-words-randomly-from-list-of-unique-words

//USE RUN-LIST.txt (modify file it reads using $1 (terminal entry variable (filename))

